    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------
    028     * AxisLocation.java
    029     * -----------------
    030     * (C) Copyright 2003-2008, by Object Refinery Limited and Contributors.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   Nick Guenther;
    034     *
    035     * Changes:
    036     * --------
    037     * 02-May-2003 : Version 1 (DG);
    038     * 03-Jul-2003 : Added isTopOrBottom() and isLeftOrRight() methods (DG);
    039     * 13-Aug-2003 : Fixed readResolve() bug (id=788202) (DG);
    040     * 24-Mar-2004 : Added static getOpposite() method (DG);
    041     * ------------- JFREECHART 1.0.x ---------------------------------------------
    042     * 22-Mar-2007 : Added getOpposite() method, suggested by Nick Guenther (DG);
    043     *
    044     */
    045
    046    package org.jfree.chart.axis;
    047
    048    import java.io.ObjectStreamException;
    049    import java.io.Serializable;
    050
    051    /**
    052     * Used to indicate the location of an axis on a 2D plot, prior to knowing the
    053     * orientation of the plot.
    054     */
    055    public final class AxisLocation implements Serializable {
    056
    057        /** For serialization. */
    058        private static final long serialVersionUID = -3276922179323563410L;
    059
    060        /** Axis at the top or left. */
    061        public static final AxisLocation TOP_OR_LEFT = new AxisLocation(
    062                "AxisLocation.TOP_OR_LEFT");
    063
    064        /** Axis at the top or right. */
    065        public static final AxisLocation TOP_OR_RIGHT = new AxisLocation(
    066                "AxisLocation.TOP_OR_RIGHT");
    067
    068        /** Axis at the bottom or left. */
    069        public static final AxisLocation BOTTOM_OR_LEFT = new AxisLocation(
    070                "AxisLocation.BOTTOM_OR_LEFT");
    071
    072        /** Axis at the bottom or right. */
    073        public static final AxisLocation BOTTOM_OR_RIGHT = new AxisLocation(
    074                "AxisLocation.BOTTOM_OR_RIGHT");
    075
    076        /** The name. */
    077        private String name;
    078
    079        /**
    080         * Private constructor.
    081         *
    082         * @param name  the name.
    083         */
    084        private AxisLocation(String name) {
    085            this.name = name;
    086        }
    087
    088        /**
    089         * Returns the location that is opposite to this location.
    090         *
    091         * @return The opposite location.
    092         *
    093         * @since 1.0.5
    094         */
    095        public AxisLocation getOpposite() {
    096            return getOpposite(this);
    097        }
    098
    099        /**
    100         * Returns a string representing the object.
    101         *
    102         * @return The string.
    103         */
    104        public String toString() {
    105            return this.name;
    106        }
    107
    108        /**
    109         * Returns <code>true</code> if this object is equal to the specified
    110         * object, and <code>false</code> otherwise.
    111         *
    112         * @param obj  the other object (<code>null</code> permitted).
    113         *
    114         * @return A boolean.
    115         */
    116        public boolean equals(Object obj) {
    117
    118            if (this == obj) {
    119                return true;
    120            }
    121            if (!(obj instanceof AxisLocation)) {
    122                return false;
    123            }
    124            AxisLocation location = (AxisLocation) obj;
    125            if (!this.name.equals(location.toString())) {
    126                return false;
    127            }
    128            return true;
    129
    130        }
    131
    132        /**
    133         * Returns the location that is opposite to the supplied location.
    134         *
    135         * @param location  the location (<code>null</code> not permitted).
    136         *
    137         * @return The opposite location.
    138         */
    139        public static AxisLocation getOpposite(AxisLocation location) {
    140            if (location == null) {
    141                throw new IllegalArgumentException("Null 'location' argument.");
    142            }
    143            AxisLocation result = null;
    144            if (location == AxisLocation.TOP_OR_LEFT) {
    145                result = AxisLocation.BOTTOM_OR_RIGHT;
    146            }
    147            else if (location == AxisLocation.TOP_OR_RIGHT) {
    148                result = AxisLocation.BOTTOM_OR_LEFT;
    149            }
    150            else if (location == AxisLocation.BOTTOM_OR_LEFT) {
    151                result = AxisLocation.TOP_OR_RIGHT;
    152            }
    153            else if (location == AxisLocation.BOTTOM_OR_RIGHT) {
    154                result = AxisLocation.TOP_OR_LEFT;
    155            }
    156            else {
    157                throw new IllegalStateException("AxisLocation not recognised.");
    158            }
    159            return result;
    160        }
    161
    162        /**
    163         * Ensures that serialization returns the unique instances.
    164         *
    165         * @return The object.
    166         *
    167         * @throws ObjectStreamException if there is a problem.
    168         */
    169        private Object readResolve() throws ObjectStreamException {
    170            if (this.equals(AxisLocation.TOP_OR_RIGHT)) {
    171                return AxisLocation.TOP_OR_RIGHT;
    172            }
    173            else if (this.equals(AxisLocation.BOTTOM_OR_RIGHT)) {
    174                return AxisLocation.BOTTOM_OR_RIGHT;
    175            }
    176            else if (this.equals(AxisLocation.TOP_OR_LEFT)) {
    177                return AxisLocation.TOP_OR_LEFT;
    178            }
    179            else if (this.equals(AxisLocation.BOTTOM_OR_LEFT)) {
    180                return AxisLocation.BOTTOM_OR_LEFT;
    181            }
    182            return null;
    183        }
    184
    185    }